;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;   Assembly õ 
;       gcc AT&T   ڵ带  Ⱦ 
;   
;   Written By KKAMAGUI, http://kkamagui.egloos.com
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
[bits 32]

;  Ŀ  Ѱ ް ó ͸ Ҷ  ɵ
global _kInit, _kRefleshRegister
global _kTest
;  ȭ ¿  Լ
global _kPrintchxy_low, _kPrintxyn_low, _kPrintxy_low, _kSetCursor_low  
global _kScrollDown_low, _kClearScreen_low
;    ƾ
global _kLoadGdt, _kLoadIdt, _kWriteCr0, _kReadCr0, _kChangeCs, 
global _kLoadLdt, _kLoadTr, _kSaveTr
global _kReadFlags16, _kReadFlags32, _kWriteFlags32,  _kWriteFs, _kWriteGs 
global _kWriteCr3, _kReadCr3, _kReadCr3Test, _kReadCr2, _kWriteCr2
;  ͷ  ƾ
global _kClearInt, _kSetInt, _kSetTimerInterval, _kClearTs, _kInitFpu 
global _kInSection, _kLock, _kUnlock
;  PIC  ƾ
global _kInitPic, _kGetMasterPicImr, _kGetSlavePicImr
global _kSetMasterPicImr, _kSetSlavePicImr, _kRestoreDosPic, _kSendMasterEoi
global _kSendSlaveEoi
;  Port   ƾ
global _kReadPortB, _kWritePortB, _kReadPortW, _kWritePortW
;  Task  ƾ
global _kSwitchTask, _kFork
;  Memory   ƾ.
global _kMemSet, _kMemSetW, _kMemSetD, _kMemCpy, _kMemCmp
;    ƾ
global _kReboot, _kSystemCallTestTask
;  ׷  ƾ
global _kVSync
;  Other Device  ƾ
global _setMouse
;  Idle  ƾ
global _kIdle

extern _main, _kInternalFork

section .text

;  ó Kernel Ǹ ׸Ʈ ͸ ٽ    Ѵ.
;  Ư     Ǹ ϸ
;  ߸  ÿ  Ѵ.
_kInit:
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;  ϴ  Ű 0x28 Code Offset
	;  0x30 DataOffset ִ.
	;  ׸ Video Offset  0x18 ִ.
	;  ⺻ 
	mov      ax, 0x10
	mov      ds, ax
	mov      ss, ax
	mov      es, ax
	mov      gs, ax
	mov      fs, ax
	mov      ebp, 0x3fffff ;   Base 4M   Ѵ.
	mov      esp, 0x3fffff ;
	;  ׸  Լ Call Ѵ.
	call     _main
	;  Ʒ ɼ .
	jmp      $

;	  GDT lgdt   ְ ο ׸Ʈ ͷ 
;	Ѵ.
;		KLoader Ѿ 0x28 ڵ ׸Ʈ 0x30  ׸Ʈε 
;		  GDT 0x08 ڵ ׸Ʈ 0x10  ׸Ʈ ȴ.
_kRefleshRegister :
		push     ebp
		mov      ebp, esp
		push     eax
		push     ebx

		mov      eax, dword [ss:esp]

		;  ׸ wGdtrOffet ̿Ͽ GDT  Ѵ.
		mov      ebx, dword [ss:ebp + 8]
		lgdt     [ds:ebx]
		mov      ebx, eax 
		;  ׸ GDT  ǾǷ 0x08 Kernel Code 
		;  ̹Ƿ ׸  Ѵ.
		jmp      0x08:Here

	Here:
		;  ׸ 0x10 Kernel Data ̹Ƿ
		;   Ѵ. ٵ  ᱹ Ȱ ũ ġ
		;  Ʋ̴.
		mov      ax, 0x10
		mov      ds, ax
		mov      es, ax
		mov      ss, ax
		mov      gs, ax
		mov      fs, ax

		pop      ebx
		pop      eax
		pop      ebp

		retn

;   ״ ׽Ʈ
_kTest :
	push     ebp
	;  ׸ Video ޸ 
	;  ȭ鿡   
	mov      ax, 0x20
	mov      gs, ax
	mov      byte [gs:0x02], 'b'
	mov      byte [gs:0x03], 0x03
	pop      ebp
	retn

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;  ȭ ¿  Լ
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  word selector, char  : 
;     selector  ġ   ϳ ´.
_kPrint :
	push     ebp
	mov      ebp, esp 
	push     ebx

	xor      eax, eax
	xor      ebx, ebx

	;  ù° ׸Ʈ 
	mov      eax, dword [ss:ebp + 8]
	mov      gs, ax
	;  °  
	mov      eax, dword [ss:ebp + 12]
	mov      byte [gs:0x00], al

	mov      eax, dword [ss:ebp + 16]
	mov      byte [gs:0x02], al

	mov      eax, dword [ss:ebp + 20]
	mov      byte [gs:0x04], al

	pop      ebx
	pop      ebp
	retn

;  word selector, int x, int y, char, int attr : 
;     selector  ġ  attr  ϳ ´.
_kPrintchxy_low :
	push  ebp
	mov   ebp, esp 
	push  ebx
	push  eax
	push  gs

	xor      eax, eax
	xor      ebx, ebx

	;  ù° ׸Ʈ 
	mov      eax, dword [ss:ebp + 8]
	mov      gs, ax
	;  ι° x ǥ 
	mov      eax, dword [ss:ebp + 12]
	mov      bx, 2
	mul      bx 
	mov      ebx, eax
	;  ° y  ǥ
	mov      eax, 160
	mul      word [ss:ebp + 16]
	add      ebx, eax
	;  ׹°  
	mov      eax, dword [ss:ebp + 20]
	mov      byte [gs:ebx], al
	;  ټ° Ӽ
	mov      eax, dword [ss:ebp + 24]
	mov      byte [gs:ebx+1], al

	pop      gs
	pop      eax
	pop      ebx
	pop      ebp

	retn

;  word selector, int x, int y, string, int count, int attr : 
;     selector  ġ  attr Ʈ countŭ ´
_kPrintxyn_low :
	push  ebp
	mov   ebp, esp 
	push  ebx
	push  eax
	push  ecx
	push  esi
	push  edi
	push  es
	push  gs

	xor      eax, eax
	xor      ebx, ebx

	;  ù° segment selector
	mov      eax, dword [ss:ebp + 8]
	mov      gs, ax
	;  ι° x ǥ 
	mov      eax, dword [ss:ebp + 12]
	mov      bx, 2
	mul      bx 
	mov      ebx, eax
	;  ° y  ǥ
	mov      eax, 160
	mul      word [ss:ebp + 16]
	add      ebx, eax
	;  ׹°  Ʈ 
	mov      esi, dword [ss:ebp + 20]
	;  ټ°    
	mov      ecx, dword [ss:ebp + 24]
	;  °  Ӽ
	mov      eax, dword [ss:ebp + 28]
	;  ׸  
	mov      edi, ebx
	;   cx  0 ̸ ׳ .
	cmp      ecx, 0
	je       kPrintxynExit

	PRINTXYN_LABLE:
		mov      ah, byte [ds:esi]
		mov      byte [gs:ebx], ah
		inc      ebx
		mov      byte [gs:ebx], al
		inc      ebx
		inc      esi
		dec      cx
		cmp      cx, 0
		ja    PRINTXYN_LABLE
   
	kPrintxynExit:
		pop      gs
		pop      es
		pop      edi
		pop      esi
		pop		 ecx
		pop      eax
		pop      ebx
		pop      ebp
		retn

;  word selector, int x, int y, stringPtr, int attr : 
;     selector  ġ  attr Ʈ countŭ ´
_kPrintxy_low :
	push  ebp
	mov   ebp, esp 
	push  ebx
	push  eax
	push  esi
	push  edi
	push  es
	push  gs

	xor      eax, eax
	xor      ebx, ebx

	;  ù° segment selector
	mov      eax, dword [ss:ebp + 8]
	mov      gs, ax
	;  ι° x ǥ 
	mov      eax, dword [ss:ebp + 12]
	mov      bx, 2
	mul      bx 
	mov      ebx, eax
	;  ° y  ǥ
	mov      eax, 160
	mul      word [ss:ebp + 16]
	add      ebx, eax
	;  ׹°  Ʈ 
	mov      esi, dword [ss:ebp + 20]
	;  ټ°  Ӽ  
	mov      eax, dword [ss:ebp + 24]
	;  ׸  
	mov      edi, ebx

	PRINTXY_LABLE:
		mov      ah, byte [ds:esi]
		mov      byte [gs:ebx], ah
		inc      ebx
		mov      byte [gs:ebx], al
		inc		 ebx
		inc      esi
		cmp      ah, 0
		jne      PRINTXY_LABLE
   
	kPrintxyExit:
		pop      gs
		pop      es
		pop      edi
		pop      esi
		pop      eax
		pop      ebx
		pop      ebp
		retn

;  dword x, dword y : 
;     x, yġ Ŀ ű.
;  Ʈ :
;     0x03d4 : VGA CRT ε 
;     0x03d5 : VGA CRT     Ѵ.
;        0x0e Ϳ  ޸  ּ
;        0x0f Ϳ  ޸  ּ
;        .
_kSetCursor_low :
	push  ebp
	mov   ebp, esp
	push  ebx
	push  edx
	push  eax
	pushfd

	;  Yǥ ϴ ؼ
	mov      eax, 80
	mov      ebx, dword [ss:ebp + 12] ;28
	mul      ebx
	;  Xǥ Ѵ.
	mov      ebx, dword [ss:ebp + 8] ;24
	add      eax, ebx
	mov      ebx, eax

	;   Offset Ѵ.
	mov      dx, 0x03d4
	mov      ax, 0x0e
	out      dx, al
	mov      dx, 0x03d5
	mov      eax, ebx
	shr      eax, 8
	out      dx, al

	;   Offset Ѵ.
	mov      dx, 0x03d4
	mov      ax, 0x0f
	out      dx, al
	mov      dx, 0x03d5
	mov      eax, ebx
	out      dx, al

	popfd
	pop      eax
	pop      edx
	pop      ebx
	pop      ebp 

	retn

;  DWORD dwVideoDesc : 
;     ȭ Ʒ ũ Ų.
_kScrollDown_low:
		push     ebp
		mov      ebp, esp
		push     ds
		push     es
		push     ecx
		push     eax
		push     esi
		push     edi

		mov      eax, dword [ss:ebp + 8]
		mov      es, ax
		mov      ds, ax
		mov      ecx, 880
		mov      esi, 320   ;  160   
		mov      edi, 160   ;   ̰  ġ
		rep      movsd
   

		;  ׸   24° 0  .
		mov      ecx, 80
		mov      eax, 3680  ; 160 * 23

	kScrollDownLoop:
		mov      byte [es:eax], 0x00
		inc      eax  
		mov      byte [es:eax], 0x07
		inc      eax
		dec      ecx
		cmp      ecx, 0
		ja       kScrollDownLoop
	pop      edi
	pop      esi
	pop      eax
	pop      ecx
	pop      es
	pop      ds
	pop      ebp
   
   retn

;  DWORD dwVideoDesc : 
;     ȭ  . ù°  ù°  ̴.
_kClearScreen_low:
		push     ebp
		mov      ebp, esp

		push     gs
		push     ecx
		push     eax
		push     edi

		mov      edi, 160
		mov      eax, dword [ss:ebp+8]
		mov      gs, ax
		mov      ecx, 1840 

	kClearScreenLoop:
		mov      byte [gs:edi], 0x00
		inc      edi 
		mov      byte [gs:edi], 0x07
		inc      edi
		dec      ecx
		cmp      ecx, 0
		ja       kClearScreenLoop
   
		pop      edi
		pop      eax
		pop      ecx
		pop      gs
		pop      ebp
   
   retn

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;    ƾ
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  DWORD dwOffset
;     CR0   о ִ´.
_kReadCr0:
	push  ebp
	mov   ebp, esp
	push  edx
	push  eax

	mov      edx, dword [ss:ebp + 8]
	mov      eax, cr0
	mov      dword [edx], eax

	pop      eax
	pop      edx
	pop      ebp
	retn

;  word cr0 :
;     CR0   Ѵ.
_kWriteCr0:
	push  ebp
	mov   ebp, esp
	push  eax

	mov      eax, dword [ss:ebp + 8]
	mov      cr0, eax

	pop      eax
	pop      ebp
	retn
   
;  dword dwValue:
;     CR3(PDTR)   .
_kWriteCr3:
	push     ebp
	mov      ebp, esp
	push     eax

	mov      eax, dword [ss:ebp + 8]
	mov      cr3, eax

	pop      eax
	pop      ebp
	retn

;  DWORD dwOffset:
;     CR3(PDTR)   д´.
_kReadCr3:
	push     ebp
	mov      ebp, esp
	push     edx
	push     eax

	mov      edx, dword [ss:ebp + 8]
	mov      eax, cr3
	mov      dword [edx], eax

	pop      eax
	pop      edx
	pop      ebp
	retn

;  dword dwValue:
;     CR2(PDTR)   .
_kWriteCr2:
	push     ebp
	mov      ebp, esp
	push     eax

	mov      eax, dword [ss:ebp + 8]
	mov      cr2, eax

	pop      eax
	pop      ebp
	retn

;  DWORD dwOffset:
;     CR2(PDTR)   д´.
_kReadCr2:
	push     ebp
	mov      ebp, esp
	push     edx
	push     eax

	mov      edx, dword [ss:ebp + 8]
	mov      eax, cr2
	mov      dword [edx], eax

	pop      eax
	pop      edx
	pop      ebp
	retn

;  CR3(PDTR)   д´.
_kReadCr3Test:
	push     ebp
	mov      ebp, esp
	push     edx
	push     eax

	mov      edx, dword [ss:ebp + 8]
	mov      eax, cr3
	mov      dword [edx], 'abcd';eax

	pop      eax
	pop      edx
	pop      ebp
	retn


;  word cs :   
;     CS   Ѵ.( ȣ <-->  )
;     ȯ CS ȯ ʿ
_kChangeCs:
		push  ebp
		mov   ebp, esp
		push  eax

		mov      ax, word [ss:ebp + 8]
		push     ax
		mov      eax, JMPPOINT
		push     ax
		retf

	JMPPOINT:
		pop      eax
		pop      ebp
		retn

;  word offset gdtr :
;     GDTR  gdtr Ϳ ϱ  Լ
_kLoadGdt:
	push  ebp
	mov   ebp, esp
	push  edx

	mov      edx, dword [ss:ebp + 8]
	lgdt     [edx]

	pop      edx
	pop      ebp
	retn

;  word offset idtr
;     IDTR  idtr Ϳ ϱ  Լ
_kLoadIdt:
	push  ebp
	mov   ebp, esp
	push  edx

	mov      edx, dword [ss:ebp + 8]
	lidt     [edx]

	pop      edx
	pop      ebp
	retn

;  word ldtOffset :
;     LDT ũ ͸ Ѵ.
_kLoadLdt:
	push ebp
	mov  ebp, esp
	push eax

	mov  ax, word [ss:ebp + 8]
	lldt ax

	pop	eax
	pop  ebp
	retn

;  word  selector
;     TR Ϳ ʱⰪ Ѵ. 
_kLoadTr:
	push	ebp
	mov  ebp, esp
	push eax

	mov  ax, word [ss:ebp + 8]
	ltr  ax

	pop  eax
	pop  ebp
	retn

;  .
;     TR  Ѵ. 
_kSaveTr:
	xor	eax, eax
	str  ax
	retn
   
;   :
;     16Ʈ ÷   ´.
_kReadFlags16:
	pushf

	mov	ax, word [ss:esp]

	add esp, 2
	retn

;  :
;     32Ʈ ÷   ´.
_kReadFlags32:
	pushfd

	; ÷  
	mov	eax, dword [ss:esp]

	add esp, 4
	retn

;  DWORD dwValue:
;     32Ʈ ÷   Ѵ.
_kWriteFlags32:
	push	ebp
	mov     ebp, esp
	push    edx

	; ó Ķ
	mov      edx, dword [ss:ebp + 8]
	; ׸ ÿ  ϰ
	; POPfd Ͽ ÷ Ϳ ϰ Ѵ.
	push     edx

	popfd
	pop      edx
	pop      ebp
	retn

;  word  wValue :
;     fs Ϳ  . ζ   ʴ 
_kWriteFs:
	push     ebp
	mov      ebp, esp
	push     eax

	mov      ax, word [ss:ebp + 8]
	mov      fs, ax

	pop      eax
	pop      ebp
	retn

;  word wValue :
;     gs Ϳ  . ζ   ʴ .
_kWriteGs:
	push  ebp
	mov   ebp, esp
	push  eax

	mov      ax, word [ss:ebp + 8]
	mov      gs, ax

	pop      eax
	pop      ebp
	retn

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;  ͷ  ƾ
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  ͷ͸ Ұ · .
_kClearInt:
	cli
	retn

;  ͷ͸ ɻ· .
_kSetInt:
	sti
	retn

;  DWORD dwTimerInterval :
;     Timer ߻  Ѵ.
;     Timer ߻ Ʒ .
;     ʴ ߻ϴ Ƚ = 0xffff / ߻
;     Ʈ 0x40  Է ָ ȴ.
_kSetTimerInterval :
	push     ebp
	mov      ebp, esp
	push     eax

	mov      al, 00110100b
	out      0x43, al

	mov      eax, dword [ss:ebp + 8]
	out      0x40, al
	mov      al, ah
	out      0x40, al

	pop      eax
	pop      ebp
	retn

;   :
;     CR0 TSƮ 0  .
_kClearTs :
	clts
	retn

;   :
;     FPU  ʱȭ Ѵ.
_kInitFpu :
	fninit
	retn

;   :
;     ͷ͸ Disable Ű 32Bit Register  Ѵ.
_kInSection:
	pushfd

	; ÷   ´.
	mov  eax, dword [ss:esp]

	; ͷ Disable
	cli
	add esp, 4
	retn


; 	BYTE *pbFlag :
;		÷  0 ̸ 1 Ű 1 ϰ,
;		÷  1 ̸ 0 Ѵ.
_kLock:
		push    ebp
		mov     ebp, esp
		push	ebx

		mov		al, 0
		mov		ah, 1

		mov		ebx, dword [ss:ebp + 8 ]
		; ޸  al  ah ޸𸮿 ְ zf 1 
		lock	cmpxchg byte [ds:ebx], ah
		je		LOCKSUCCESS
		mov		eax, 0
		jmp		LOCKEND

LOCKSUCCESS:		
		mov		eax, 1
		jmp		LOCKEND

LOCKEND:
		pop	ebx
		pop ebp
		retn

; 	BYTE *pbFlag :  
;     ͷ͸ Disable Ű ÷׸ ˻Ͽ
;		÷  1 ̸ 0 ҽŰ 1 ϰ
;		÷  0 ̸ 0 Ѵ.
_kUnlock:
		push ebp
		mov ebp, esp
		push	ebx

		mov		al, 1
		mov		ah, 0

		mov		ebx, dword [ss:ebp + 8 ]
		; ޸  al  ah ޸𸮿 ְ zf 1 
		lock	cmpxchg byte [ds:ebx], ah
		je		UNLOCKSUCCESS
		mov		eax, 0
		jmp		UNLOCKEND

UNLOCKSUCCESS:		
		mov		eax, 1
		jmp		UNLOCKEND

UNLOCKEND:
		pop	ebx
		pop ebp
		retn



; 	BYTE *pbFlag : 
;     ͷ͸ Disable Ű, ÷׸ ˻Ͽ
;		÷  0 ̸ 1 Ű 1 ϰ,
;		÷  1 ̸ 0 Ѵ.
_kLockOld:
		push    ebp

		mov     ebp, esp
		push    ebx
		pushfd

		; ÷ ͸ ´.
		mov     ebx, dword [ss:ebp + 8]
		; ͷ Disable
		cli
		mov		al, byte [ds:ebx]
		cmp		al, 0
		; ϴ FALSE  
		mov		eax, 0x00000000
		jne		kLockExit

		mov		byte [ds:ebx], 0x01
		mov		eax, 0x01

	kLockExit:
		popfd
		pop     ebx
		pop     ebp
		retn

; 	BYTE *pbFlag :  
;     ͷ͸ Disable Ű ÷׸ ˻Ͽ
;		÷  1 ̸ 0 ҽŰ 1 ϰ
;		÷  0 ̸ 0 Ѵ.
_kUnlockOld:
		push    ebp

		mov     ebp, esp
		push    ebx
		pushfd

		; ÷ ͸ ´.
		mov      ebx, dword [ss:ebp + 8]
		; ͷ Disable
		cli
		mov		al, byte [ds:ebx]
		cmp		al, 1
		; ϴ FALSE  
		xor      eax, eax
		jne		kUnLockExit

		mov		byte [ds:ebx], 0
		mov		eax, 0x01

	kUnLockExit:
		popfd
		pop		ebx
		pop      ebp
		retn

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;  PIC  Լ
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  byte IRQStartOffset  :  
;     IRQ0  ġ INT ȣ ش. 
;     0x20 ָ IRQ0 INT 0x20 ġȴ.
;  ps)IRQ ʱȭ Ҷ ICW1 ִ ɿ  2ܰ 3ܰ 4ܰ踦 ģ.
;      Ʈ ICW1   ϰ
;      Ʈ ICW2,3,4  ϴ  PIC ʱȭ Ҽ ִ.
PICMASTERCPORT equ   0x20
PICMASTERDPORT equ   0x21
PICSLAVECPORT  equ   0xa0
PICSLAVEDPORT  equ   0xa1
;   Ʈ Ʈ̰  Ʈ  Ʈ + 1  ȴ.

;  word INToffset :  
;      1Ʈ Master Offset
;      1Ʈ Slave Offset .
_kInitPic :
	push     ebp
	mov      ebp, esp
	push     eax

	;  ϴ  PIC  Ѵ.
	mov      al, 00010001b           ;  ICW1 ,  Ʈ, ̺, ICW4ʿ
	out      PICMASTERCPORT, al
	mov      ax, word [ss:ebp + 8]    ;  ICW2 , IRQ INT ȣ ġ
	shr      ax, 8
	out      PICMASTERDPORT, al
	mov      al, 00000100b           ;  ICW3 , IR2 ̺ 
	out      PICMASTERDPORT, al
	;mov  al, 00011101b              ;  ICW4 , Ȯ, MASTER, Normal EOI, 86
	mov      al, 00000001b
	out      PICMASTERDPORT, al
	mov      al, 0
	out      PICMASTERDPORT, al

	;  ׸ ̺ PIC 
	mov      al, 00010001b           ;  ICW1 
	out      PICSLAVECPORT, al
	mov      ax, word [ss:ebp + 8]    ;  ICW2 , IRQ INT ȣ ġ
	out      PICSLAVEDPORT, al
	mov      al, 00000010b           ;  ICW3 ,  Ϳ IR2 
	out      PICSLAVEDPORT, al
	;mov  al, 00001001b      ;  Master Ȯ  ̺ ʿ ,
							;  Slave, normal EOI, 86
	mov      al, 00000001b
	out      PICSLAVEDPORT, al
	mov      al, 0
	out      PICSLAVEDPORT, al

	pop      eax
	pop      ebp
	retn

;   : 
;  return : Master IMR Ϳ Ǿִ ũ Ʈ Ѵ.
;
;      Imr ͸ о Ѵ. ͷƮ ũ  
;     1 Ȱ ߻ ʴ´.
_kGetMasterPicImr:
	;  PICMASTERPORT+1   Ʈ о Ѵ.
	in	al, PICMASTERDPORT
	retn

;   : 
;  return : Slave IMR Ϳ Ǿִ ũ Ʈ Ѵ.
;
;      Imr ͸ о Ѵ. ͷƮ ũ  
;     1 Ȱ ߻ ʴ´.
_kGetSlavePicImr:
	;  PICMASTERPORT+1   Ʈ о Ѵ.
	in	al, PICSLAVEDPORT
	retn

;  word maskbit :  Ʈ Ѵ.
;     Data Port OCW1  Ͽ IMR  ٲ۴.
_kSetMasterPicImr :
	push ebp
	mov  ebp, esp
	push eax

	mov  ax, word [ss:ebp + 8]
	out  PICMASTERDPORT, al  ;  OCW1  IMR ũ 

	pop  eax
	pop  ebp
	retn

;  word maskbit :  Ʈ Ѵ.
;     Data Port OCW1  Ͽ IMR  ٲ۴.
_kSetSlavePicImr :
	push  ebp
	mov   ebp, esp
	push  eax

	mov   ax, word [ss:ebp + 8]
	out   PICSLAVEDPORT, al   ;  OCW1  IMR ũ 

	pop   eax
	pop   ebp
	retn

;   :
;     DOS   ͷͷ  Ѵ.
_kRestoreDosPic :
	;  ϴ  PIC  Ѵ.
	push ebp
	mov  ebp, esp
	push eax

	mov  al, 00010001b ;  ICW1 ,  Ʈ, ̺, ICW4ʿ
	out  PICMASTERCPORT, al
	mov  al, 00001000b ;  ICW2 , IRQ INT ȣ ġ
	out  PICMASTERDPORT, al
	mov  al, 00000100b ;  ICW3 , IR2 ̺ 
	out  PICMASTERDPORT, al
	mov  al, 00000001b ;  ICW4 , Normal EOI, 86
	;  ׸ ̺ PIC 
	mov  al, 00010001b ;  ICW1 
	out  PICSLAVECPORT, al
	mov  al, 01110000b ;  ICW2 , IRQ INT ȣ ġ
	out  PICSLAVEDPORT, al
	mov  al, 00000010b ;  ICW3 ,  Ϳ IR2 
	out  PICSLAVEDPORT, al
	mov  al, 00000001b ;  normal EOI, 86

	pop  eax
	pop  ebp
	retn

EOI equ  0x20
;   :
;     Master PIC EOI Ŀǵ带 .
_kSendMasterEoi :
	push     eax

	mov      al, EOI ;  OCW2 , ͷ  
	out      PICMASTERCPORT, al

	pop      eax
	retn

;   :
;     Slave PIC EOI Ŀǵ带 .
_kSendSlaveEoi :
	push     eax

	mov      al, EOI ;  OCW2 , ͷ  
	out      PICSLAVECPORT, al
	mov      al, EOI
	out      PICMASTERCPORT, al

	pop      eax
	retn

;   :
;     Port ѹƮ о Ѵ.
_kReadPortB :
	push  ebp
	mov   ebp, esp 
	push  edx

	mov   dx, word [ss:ebp + 8]
	xor   ax, ax
	in    al, dx

	pop   edx
	pop   ebp
	retn

;   :
;     Port ιƮ о Ѵ.
_kReadPortW :
	push  ebp
	mov   ebp, esp 
	push  edx

	mov   dx, word [ss:ebp + 8]
	xor   ax, ax
	in    ax, dx

	pop   edx
	pop   ebp
	retn

;  word wPortNumber, word wData 
_kWritePortB :
	push  ebp
	mov   ebp, esp
	push  edx
	push  eax

	;  ϴ Ʈ ȣ ´.
	mov   dx, word [ss:ebp + 8]
	;  ׸ Ʈ ͸ ´.
	mov      al, byte [ss:ebp + 12]
	out      dx, al

	pop      eax
	pop      edx
	pop      ebp
	retn
   
;  word wPortNumber, word wData 
_kWritePortW :
	push  ebp
	mov   ebp, esp
	push  edx
	push  eax

	;  ϴ Ʈ ȣ ´.
	mov   dx, word [ss:ebp + 8]
	;  ׸ Ʈ ͸ ´.
	mov      ax, word [ss:ebp +12]
	out      dx, ax

	pop      eax
	pop      edx
	pop      ebp
	retn

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;  Memory   ƾ
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;  dword dwOffset, BYTE charactor, dword dwCount :
;     offset Ű  dwCount  charactor ä.
_kMemSet :
	push    ebp
	mov     ebp, esp

	push    eax
	push    edx
	push    ecx
	push    esi

	;  ù° Ķ   ޸ Offset
	mov     eax, dword [ss:ebp + 8]
	mov     edx, eax
	;  ι° Ķ ä 
	mov     eax, dword [ss:ebp + 12]
	;  ° Ķ īƮ
	mov     ecx, dword [ss:ebp + 16]
	; Fill Full 4Byte
	xor     esi, esi
	and     eax, 0x000000FF
	or      esi, eax
	shl     eax, 8
	or      esi, eax
	shl     eax, 8
	or      esi, eax
	shl     eax, 8
	or      esi, eax
	shl		eax, 8
	or      esi, eax
	mov     eax, esi

	cmp		ecx, 0
	je      kMemSetExit
	cmp     ecx, 4
	jb      kMemSetLoop
		
	kMemSetLoopD :
		mov		dword [edx], eax
		add		edx, 4
		sub		ecx, 4
		cmp		ecx, 4
		jae		kMemSetLoopD	   
	
	cmp	    ecx, 0
	je      kMemSetExit
	
	kMemSetLoop :
		mov     byte [edx], al
		inc     edx
		dec     ecx
		cmp     ecx, 0
		ja      kMemSetLoop
	
	kMemSetExit :

    pop		esi
    pop     ecx
    pop     edx
    pop     eax
    pop     ebp
    retn

;
;  dword dwOffset, WORD wData, dword dwCount :
;     offset Ű  dwCount  wData ä.
_kMemSetW :
	push    ebp
    mov     ebp, esp

    push    eax
    push    edx
    push    ecx
    push    esi

    ;  ù° Ķ   ޸ Offset
    mov     eax, dword [ss:ebp + 8]
    mov     edx, eax
    ;  ι° Ķ ä 
    mov     eax, dword [ss:ebp + 12]
    ;  ° Ķ īƮ
    mov     ecx, dword [ss:ebp + 16]
	; Fill Full 4Byte
	xor		esi, esi
	and     eax, 0x0000FFFF
	or      esi, eax
	shl		eax, 16
	or      esi, eax
	mov     eax, esi

	cmp     ecx, 0
	je      kMemSetExitW
	cmp     ecx, 2
	jb      kMemSetLoopW
		
	kMemSetLoopWD :
        mov     dword [edx], eax
        add     edx, 4
        sub     ecx, 2
        cmp     ecx, 2
        jae     kMemSetLoopWD	   
	
	cmp     ecx, 0
	je      kMemSetExitW
	
    kMemSetLoopW :
        mov     word [edx], ax
        add     edx, 2
        dec     ecx
        cmp     ecx, 0
        ja      kMemSetLoopW
	
	kMemSetExitW :

    pop     esi
    pop     ecx
    pop     edx
    pop     eax
    pop     ebp
    retn

;
;  dword dwOffset, DWORD dwData, dword dwCount :
;     offset Ű  dwCount  dwData ä.
_kMemSetD :
    push    ebp
    mov     ebp, esp

    push    eax
    push    edx
    push    ecx
    push    esi

    ;  ù° Ķ   ޸ Offset
    mov     eax, dword [ss:ebp + 8]
    mov     edx, eax
    ;  ι° Ķ ä 
    mov     eax, dword [ss:ebp + 12]
    ;  ° Ķ īƮ
    mov     ecx, dword [ss:ebp + 16]
		
    kMemSetLoopDD :
        mov	    dword [edx], eax
        add	    edx, 4
        dec	    ecx
        cmp	    ecx, 0
        ja      kMemSetLoopDD	   

    pop     esi
    pop     ecx
    pop     edx
    pop     eax
    pop     ebp
    retn


;  dword dwTargetOffset, dword dwSourceOffset, dword dwCount :
;     dwTargetOffset ġ dwSourceOffset  dwCountŭ Ѵ.
;     
_kMemCpy :
    push  ebp
    mov   ebp, esp

    push  eax
    push  ecx
    push  esi
    push  edi
    push  edx

    ;  ù° ĶͰ Ÿ 
    mov   edi, dword [ss:ebp + 8]
    ;  ι° ĶͰ ҽ 
    mov   esi, dword [ss:ebp + 12]
    ;  ° ĶͰ ű 
    mov   eax, dword [ss:ebp + 16]
      
    cmp	eax, 0
    je  kMemCpyExit

    cmp	eax, 4
    jb  kMemCpy1

    xor	edx, edx
    mov	ecx, 4
    div	ecx
    mov	ecx, eax
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;   ޸𸮿 ִ Ŀ о 鿩  Ѵ.
    ;  ϴ movsd  si  di  ϳ Ű Ѵ.
    ;  df = 0 ̸  1 ̸ 
    cld
    rep movsd
    jmp kMemCpy

	kMemCpy1:
        mov	edx, eax
	
	kMemCpy :
        ; remain Fill
        mov	ecx, edx
        cmp	ecx, 0
        je  kMemCpyExit

        rep movsb

	kMemCpyExit :
    pop     edx
    pop     edi
    pop     esi
    pop     ecx
    pop     eax
    pop     ebp
    retn


;  dword dwTargetOffset, dword dwSourceOffset, dword dwCount :
;     dwTargetOffset dwSourceOffset  dwCountŭ Ѵ.
;     dwTargetOffset - dwSourceOffset  Ѵ.
;       0  ٸ ( > 0 ) Ǵ ( 0 < )  ϵȴ.
_kMemCmp :
    push  ebp
    mov   ebp, esp

    push  ebx
    push  ecx
    push  esi
    push  edi

    xor   eax, eax
    ;  ù° ĶͰ Ÿ 
    mov   edi, dword [ss:ebp + 8]
    ;  ι° ĶͰ ҽ 
    mov   esi, dword [ss:ebp + 12]
    ;  ° ĶͰ ű 
    mov   ecx, dword [ss:ebp + 16]
    ;   Ѵ.
    cmp 	ecx, 0
    je		kMemCmpExitLoop
	
	kMemCmpLoopD :
        cmp	ecx, 4
        jb		kMemCmpLoop

    mov   eax, dword [edi]
    mov   ebx, dword [esi]
    cmp   eax, ebx 
    jb    kMemCmpMinusValueD
    sub   eax, ebx 
    sub   ecx, 4
    add   edi, 4
    add   esi, 4
      
    cmp   eax, 0
    je    kMemCmpLoopD
    jmp   kMemCmpExitLoop
    ;     ɶ ó
   
    kMemCmpMinusValueD:
        sub   ebx, eax
        mov   eax, ebx
        ;  ְ Ʈ 1  ؼ   Ѵ.
        or    eax, 0x80000000
        jmp	kMemCmpExitLoop
   
	kMemCmpLoop :
		cmp	ecx, 0
		je		kMemCmpExitLoop

    mov   al, byte [edi]
    mov   bl, byte [esi]
    cmp   al, bl
    jb    kMemCmpMinusValue
    sub   al, bl
    dec   ecx
    inc   edi
    inc   esi

    cmp   ecx, 0
    jbe   kMemCmpExitLoop

    cmp   ax, 0
    je    kMemCmpLoop
    jmp   kMemCmpExitLoop
    ;     ɶ ó
   
	kMemCmpMinusValue:
        sub   bl, al
        mov   al, bl
        ;  ְ Ʈ 1  ؼ   Ѵ.
        or    eax, 0x80000000
   kMemCmpExitLoop :
    ;    ax  ǵ .

    pop   edi
    pop   esi
    pop   ecx
    pop   ebx
    pop   ebp

    retn

;   :
;     ý Ʈѷ ϴ ۰ ⸦ ٸ.
WaitKeyBufferEmpty:
    push  eax
    push  ecx

    mov   ecx, 0x0fffff ; ѷ  ʵ
    
    WAITKEYBUFFEREMPTY_LOOP:
        in    al, 0x64      ; Write  
        test  al, 2
        loopnz   WAITKEYBUFFEREMPTY_LOOP

    pop   ecx
    pop   eax
    retn

;   :
;     Ŀ ϰ  Ų.
_kReboot :
    push  eax
    push  es

    ; ϴ ͷ͸  Ű
    ; ̷   Ʒ ƾ ϴٰ
    ; ½ũ ȯǾ     ִ
    cli
    ; For Test
    mov  ax, 0x18
    mov  es, ax
    mov  byte[es:0], '0'

    ; ׸ Ű ۰ ⸦ ٸ.
    call  WaitKeyBufferEmpty

    ; For Test
    mov  ax, 0x18
    mov  es, ax
    mov  byte[es:0], '3'

    ; ϴ ׳ Ʈ ع
    ; cold boot ԵǼ   ׽Ʈ ϰ ǹǷ
    ; ð ʹ  ɸ ׷ worm Ʈ ϱ ؼ
    ;  ̿ fix  40:72  0x1234 ־
    ; ýÿ worm Ʈ ϰ Ѵ.
    ; Worm Bootrk  ȵǴ Ҹ
    xor   eax, eax
    mov  ax, 0x10
    mov  es, ax
    mov  byte [ es : 0x0472 ], 0x34
    mov  byte [ es : 0x0473 ], 0x12

    mov   al, 0xfe      ; ý Ʈ
    out   0x64, al      ;  
    ; For Test
    mov  ax, 0x18
    mov  es, ax
    mov  byte[es:0], '4'

    jmp   $     ; ׸ ѷ

    pop   es
    pop   eax
    retn


;	ý  ȣϴ ½ũ
_kSystemCallTestTask :
    mov      ebx, dword[ ss:ebp ]
    cmp      ebx, 0

    mov      byte [0xB8000], 'A'

    mov      eax, 0x00000001
    mov		ebx, esp;0x00000002
    mov		ecx, 0x00000003
    mov		edx, 0x00000004
    mov		esi, 0x00000005
    mov		edi, 0x00000006 

    int		60

    jmp $


;  Video Mode Vertical Retrace ٸ
;     No Parameter
_kVSync:
	push  edx
	push  eax

	mov   dx, 0x03DA

	;   ̹ Vetical Retrace ̸
	;   ̹ ʾϱ Ҽ 
	kVSyncWaitAlreadyRetrace:   
		in    al, dx
		and   al, 0x08
		cmp   al, 0x08
		je    kVSyncWaitAlreadyRetrace
	;   Retrace Time ٸ
	kVSyncWaitRetrace:   
		in    al, dx
		and   al, 0x08
		cmp   al, 0
		je    kVSyncWaitRetrace

	pop   eax
	pop   edx
	retn


;     idle ƾ
_kIdle:
	hlt
	hlt
	hlt
	ret


;Task Switching Ѵ.
_kSwitchTask
	push eax
	; General Register
	; ESP, EBP, EFLAG, EAX, EBX, ECX, EDX, ESI, EDI  PushѴ.
	
	; Current Task 
	mov eax, dword [ss:esp + 8]
	push ebx

	; EFlag 
	pushfd
	mov ebx, dword [ss:esp]
	mov dword [eax + 48], ebx
	add esp, 4

    cli
	; esp 
	mov ebx, esp
	add ebx, 8
	mov dword [eax + 56], ebx
	pop ebx

	mov dword [eax + 52], ebp
	mov dword [eax + 40], ebx
	mov dword [eax + 36], ecx
	mov dword [eax + 32], edx
	mov dword [eax + 28], esi
	mov dword [eax + 24], edi
	
	; eax ִ´.
	mov ebx, eax
	pop eax
	mov dword [ebx + 44], eax

	; Segment Register
	; cs, ds, ss, es, fs, gs  PushѴ.
	mov ax, cs
	mov dword [ebx + 20], eax
	mov ax, ds
	mov dword [ebx + 16], eax
	mov ax, ss
	mov dword [ebx + 12], eax
	mov ax, es
	mov dword [ebx + 8], eax
	mov ax, fs
	mov dword [ebx + 4], eax
	mov ax, gs
	mov dword [ebx + 0], eax


	; Next Task 
	mov eax, dword [ss:esp + 8]
	mov esp, eax

	; segment register
	pop eax
	mov gs, ax
	pop eax
	mov fs, ax
	pop eax
	mov es, ax
	pop eax
	mov ss, ax
	pop eax
	mov ds, ax
	; cs    ʴ´.
	pop eax

	; General Register
	pop edi
	pop esi
	pop edx
	pop ecx
	pop ebx
	pop eax
	popfd
	pop ebp
	pop esp
	ret
